/*
 *	Type definitions for C scheduler and occam support
 *	Copyright (C) 1998 Jim Moores
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef SCHED_TYPES_H
#define SCHED_TYPES_H

#include "ukcthreads_types.h"

struct _sepflags {
  byte kbd_sync;
  byte tim_sync;
  byte block_sync;
  byte extern_flag;
};

typedef struct _sepflags sepflags;

union _sync_type {
  word combined_sync;
  sepflags s;
};

typedef union _sync_type sync_type;

#endif
