/*
 *	CSPlib time interface
 *	Copyright (C) 1998 Jim Moores
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CSPTIME_H
#define CSPTIME_H

#if 1 /*CPU_TIMERS*/
typedef signed long long Time;
extern long long Time_hz;
extern long long Time_ticks_per_hz;
extern long long Time_ticks_per_sec;
extern long long Time_ticks_per_us;
extern double Time_ticks_per_us_d;
#else
typedef int Time;
#endif

#define ProcTimePlus(X,Y) ((Time)(X) + (Time)(Y))

#define ProcTimeMinus(X,Y) ((Time)(X) - (Time)(Y))

#define ProcTimeAfter(X,Y) (ProcTimeMinus(X,Y) > 0)

#define ProcTime() FProcTime(p)

#define ProcAfter(T) Tin(T)

#endif
