#ifndef OCCAM_IO_H
#define OCCAM_IO_H

#include "ukcthreads_types.h"

void hard_print(void);
void kbd_process(void);
void init_occam_io(void *);

extern word _kbd_workspace_bottom[4];
extern word _scr_workspace_bottom[6];
extern word _err_workspace_bottom[6];

/* pointers to the right offsets into each workspace for convenience */
/* this is slightly different to an assembler label. */
extern word *kbd_workspace;
extern word *scr_workspace;
extern word *err_workspace;

/* the actual locations holding the channel words.  Obviously if the */
/* channel address is needed then the address of (&) operator must be */
/* used */
extern word kbd_chan;
extern word scr_chan;
extern word err_chan;
#endif
