/*
 *  
 * KROC ARM translator - ASSEMBLY LANGUAGE MACROS
 *
 * $Source: /extra/play/cvs/kroc/src/target/arm/amacros.h,v $
 *
 * $Id: amacros.h,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * amacros.h:
 * (C) Copyright 1998 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 *
 * Derived from alpha/amacros.h:
 * (C) Copyright D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 */

#define SET_EFLAG             mnem("orr"); STATUS; STATUS; immdec(1); NL;
#define CLR_EFLAG             mnem("bic"); STATUS; STATUS; immdec(1); NL;
#define TST_EFLAG(Dest)       mnem("and"); Dest;   STATUS; immdec(1); NL;

#define SET_HFLAG             mnem("orr"); STATUS; STATUS; immdec(2); NL;
#define CLR_HFLAG             mnem("bic"); STATUS; STATUS; immdec(2); NL;
#define TST_HFLAG(Dest)       mnem("and"); STATUS; Dest;   immdec(2); NL;

#ifdef FLOAT

#define FCLR_Reg(Freg)        fmnem("cpys");  ZERO; ZERO; str(Freg);  NL;
#define FMOV_Reg(FSrc,FDest)  fmnem("cpys");  str(FSrc); str(FSrc); str(FDest); NL;
#define FNEG_Reg(FSrc,FDest)  fmnem("cpysn"); str(FSrc); str(FSrc); str(FDest); NL;
#define FABS_Reg(FSrc,FDest)  fmnem("cpys");  ZERO; str(FSrc); str(FDest); NL;

#endif



#define CALL_RTN(dst)	mnem("IMPORT"); barstr(dst); nl; mnem("bl"); barstr(dst); NL;

/* EOF */
