/*
 * KROC SPARC translator: Instructions concerned with processes.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/f_proc.c,v $
 *
 * $Id: f_proc.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * SPARC target only.
 */

static char f_proc_c_rcsid[] = "$Id: f_proc.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "octran.h"

void ENDP ()
{	mnem("ld"); sindex(Areg, pp_Count); T0; NL;
	mnem("deccc"); T0; nl;
	if (o_kjumptable)
	{	mnem("bne"); f(1); nl; }	/* bgu? */
	else
	{	mnem("bne"); sched("scheduler"); nl; }
	mnem("st"); T0; sindex(Areg, pp_Count); DELAY; nl;
	mnem("ld"); sindex(Areg, pp_IptrSucc); L; nl;
	mnem("jmp"); L; nl;			/* adjusted */
	mnem("mov"); A; W; DELAY; nl;
	if (o_kjumptable)
	{	BREAK;
	lab(1);	extcall(X_SCHEDULER); nl;
		mnem("nop"); nl;
	}
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
	BREAK;
}

void STARTP ()
{	mnem("call"); f(1); COMMENT("get PC"); NL;	/* 0 */
	mnem("add"); B; L; B; DELAY; nl;		/* 1 */
lab(1);	mnem("inc"); dec(9*BytesPerWord); B; nl;	/* 2 */
	mnem("st"); B; sindex(Areg, -1); nl;		/* 3 */
	mnem("cmp"); FP; MIN; nl;			/* 4 */
	mnem("bne,a"); f(1); nl;			/* 5 */
	mnem("st"); A; sindex(Bptr, -2); ANNUL; nl;	/* 6 */
	mnem("mov"); A; FP; nl;				/* 7 */
lab(1);	mnem("mov"); A; BP; nl;				/* 8 */
							/* 9 */
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

void STOPP ()
{	extcall(X_STOPP); NL;
	ADJUST; nl;
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

void STHF ()
{	unimp ();
/*	mnem("mov"); A; FP; NL;	*/
	POP;
}

void STLB ()
{	mnem("mov"); A; BP; NL;
	POP;
}

void STLF ()
{	mnem("mov"); A; FP; NL;
	POP;
}

void RUNP ()
{	mnem("bclr"); dec(1); A; NL;
	mnem("cmp"); FP; MIN; nl;
	mnem("bne,a"); f(1); nl;
	mnem("st"); A; sindex(Bptr, -2); ANNUL; nl;
	mnem("mov"); A; FP; nl;
lab(1);	mnem("mov"); A; BP; nl;
	istackp = 0;
	fstackp = 0;
	ishuff = 0;
}

void SAVEH ()
{	unimp ();
/*	mnem("st"); FP; sindex(Areg, 0); NL;	*/
/*	mnem("st"); BP; sindex(Areg, 1); nl;	*/
	POP;
}

void SAVEL ()
{	mnem("st"); FP; sindex(Areg, 0); NL;
	mnem("st"); BP; sindex(Areg, 1); nl;
	POP;
}

void STHB ()
{	unimp ();
/*	mnem("mov"); A; BP; NL;	*/
	POP;
}
