!
! KROC SPARC debugging: Register dump.
!
! $Source: /extra/play/cvs/kroc/src/target/sparc/sdump.s,v $
!
! $Id: sdump.s,v 1.1 1999/09/27 21:10:13 rivimey Exp $
!
! (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
! University of Kent at Canterbury
!
! Pseudo-directives .dump and .fdump generate calls to these,
! which in turn call _dump and _fdump (in C).
!
!

#include "config.h"
#include "sched.h"

		.text
	_sdump_s_rcsid:
	.ascii	"$Id: sdump.s,v 1.1 1999/09/27 21:10:13 rivimey Exp $\0"

	.align	4
	.global	$$dump
$$dump:				!  %o0 = istackp
	mov	%o7,%o1		!  iptr/pc
	mov	%l3,%o2		!  wptr
	mov	%l2,%o3		!  a
	mov	%l1,%o4		!  b
	call	MAKENAME(dump)
	mov	%l0,%o5		!* c
	jmp	%o1+8
	nop

FPtmp	=	-8

	.global	$$fdump
$$fdump:			!  %o0 = code
	mov	%o7,%i0
	std	%f2,[%fp+FPtmp]	!  %o2:%o3 = %f2:%f3 = fb
	ldd	[%fp+FPtmp],%o2
	std	%f0,[%fp+FPtmp]	!  %o4:%o5 = %f0:%f1 = fc
	ldd	[%fp+FPtmp],%o4
	std	%f4,[%fp+FPtmp]	!  %o1    -> %f4:%f5 = fa
	call	MAKENAME(fdump)
	add	%fp,FPtmp,%o1	!*
	jmp	%i0+8
	nop
