/*
 * KROC translator: Function definitions and prototypes
 *
 * $Source: /extra/play/cvs/kroc/src/octran.h,v $
 *
 * $Id: octran.h,v 1.2 1999/09/08 17:00:29 rivimey Exp $
 *
 * stack-utils.c
 * (C) Copyright 1999 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 */

void StackPush(void)		 /* push value onto stack */
{
    if (istackp == 3) {
        if (ishuff == 0) {	/* unexpected */
            fputs ("\n*** Integer stack overflow", stderr);
            /*	error ();	*/
            where ();
        }
        else
        {
            /* expected */
            if (o_verbose)
            {
                fputs ("\n... Adjusting stack", stderr);
                where ();
            }
	    currentAsm->asmStackShift();
            shufflecount += 1;
            if (ishuff > 0)
                ishuff -= 1;
        }
    } else
        ++istackp;

/*  shufflecount += shuffle (istackp, istackp + 1); */
}


void StackPop(int n) /* pop n words off stack */
{
    istackp -= n;

    if (ishuff > istackp) {
        ishuff = istackp;
        if (o_verbose && ishuff == 0) {
            fputs ("\n... Shuffling off", stderr);
            where ();
        }
    }
}


void StackReset(void)
{
    istackp = 0;
    ishuff = 0;
}

int QueryStack()
{
    return istackp;
}

