--
--	codeprot.inc - BIN.CODE protocol
--	Copyright (C) 1997 M.D. Poole
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

VAL opt.retnormal IS 1:
VAL opt.withhex IS 2:
--{{{  PROTOCOL BIN.CODE
PROTOCOL BIN.CODE
  CASE
    sourcefile; INT::[]BYTE
    sourceline; INT
    codeline; INT
    code; INT::[]BYTE
    data; INT::[]BYTE
    main.module.top
    sub.module.top
    lib.module.bit; INT; INT
    lib.module.bottom
    main.module.bottom; INT; INT
    sub.module.bottom
    set.label; INT
    set.local.label; INT
    set.named.label; INT::[]BYTE
    load.named.label.addr; REG; INT::[]BYTE
    go.label; INT
    call.label; INT
    cj.label; INT; INT
    call.named.label; INT::[]BYTE
    go.named.label; INT::[]BYTE
    stub.import; INT::[]BYTE
    load.lab.addr; REG; INT
    load.lab.diff; REG; INT; INT
    public -- always followed by set.named.label
    align; INT
    comment; INT::[]BYTE
    option; INT
:
--}}}  
