# Support for calling blocking system calls from occam (Fred Barnes)
# Watch out for changes in the kernel, which affect the magic numbers in here..

.text
.align 4
.global _call_B_interf
_call_B_interf:
	popl	0x0(%ebp)		# get return address
	leal	0x4(%ebp),%eax		# arguments start just above Wptr
	# Pretend to be a kernel call
	pushl	%eax			# push argument ptr
	pushl	%ebx			# push function addr
	call	*-128(%esi)		# call kernel to perform blocking call
	pushl	0x0(%ebp)		# push saved return address
	addl	$16,%ebp		# restore Wptr
	ret				# return to occam
.align	4

