# Support for calling blocking system calls from occam (Fred Barnes)
# This one supports the destruction of them
# Watch out for changes in the kernel, which affect the magic numbers in here..

.text
.global _call_BX_interf
_call_BX_interf:
	popl	0x0(%ebp)		# get return address
	leal	0x4(%ebp), %eax		# arguments start just above Wptr
	# Pretend to be a kernel call
	pushl	%eax			# push Wptr[1] (where vars start)
	pushl	%ebx			# push function entry point
	call	*-132(%esi)		# call kernel to perform blocking call

	pushl	0x0(%ebp)
	addl	$16,%ebp
	ret
.align	4


