/*
 *	Definition of External_Poll()
 *	Copyright (C) 1998 Jim Moores
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Kernel-user function: bool External_Poll()
 * Called bu the kernel to poll for external events.  Returns TRUE if events
 * need to be handled.
 */
/* WAS inline, removed because easier to have multiple versions of libexcomm.a
 */
#ifndef K_USR_EXTERN_H
#define K_USR_EXTERN_H
extern bool External_Poll(); 
#endif /* k_usr_extern.h */
