/* Debugging support file
 * ====================== 
 * Copyright (C) Jim Moores 1998
 * University of Kent at Canterbury.
 */
#ifndef DEBUG_H
/* Debugging macros */
#ifdef DEBUG_KERNEL
  /* debugging enable flag */
  #define DBGMSG(args...) fprintf(stderr, ## args)
  bool db=true;
#else
  #define DBGMSG(args...) (0)
  bool db=false;
#endif

#endif /* debug.h */
