/* {{{  hard_print */
/*#ifdef OCCAM_IO*/
void hard_print()
{
    while (true)
    {
        LOADWPTR;
        
        if (Wptr[0]  == Flush)
            fflush((FILE *)Wptr[Device]);
        else
            fputc((int)(Wptr[0]), (FILE *)Wptr[Device]);
        
        /* calling a kernel function like this is a fudge */
        PUSH(&(Wptr[0]));
        PUSH(Wptr[IOChannel]);
        PUSH(1);
        RESTORE;
        ((FUNCPTR)(occam_table[Table_In])) ();
    }
}
/* }}} */

/* {{{  kbd_process */
void  kbd_process()
{
    DBGMSG("kbd_process: started.  Calling read_the_kbd.\n");
    temp1 = read_the_kbd();
    Wptr = kbd_workspace;
    DBGMSG("kbd_process: received keypress as 0x%x. Calling OutByte.\n", temp1);
    PUSH(&kbd_chan);
    PUSH(temp1);
    RESTORE; /* get Wptr into ebp */
    ((FUNCPTR)(occam_table[Table_OutByte]))();
    DBGMSG("kbd_process: returned from OutByte, acknowledging keypress.\n");
    acknowledge();
    DBGMSG("kbd_process: calling scheduler.\n");
    KJUMP(X_scheduler);
}
/* #endif */
/* }}} */

