#ifndef UKCTHREADS_TYPES_H
#define UKCTHREADS_TYPES_H

#include "csplib_consts.h"

#define NotProcess_p 0
#define true 1
#define TRUE 1
#define false 0
#define FALSE 0

typedef unsigned int word;
typedef unsigned int Channel;
typedef int bool;
typedef unsigned char byte;

#ifdef PRIORITIES
typedef word priority_t;

struct _prioratised_queue {
  word* Fptr[NumberOfPriorities];
  word* Bptr[NumberOfPriorities];
  priority_t priority_table;
};

typedef struct _prioratised_queue prioratised_queue;
#endif
#endif /* ukcthreads_types.h */
