/*
 * KROC ALPHA translator: Conditional table offset definitions
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/cond.h,v $
 *
 * $Id: cond.h,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 */


/*      Conditionals                            */
/*      Must be in true/false even/odd pairs    */

#define C_NONE          0

#define C_GT            2
#define C_LE            3
#define C_EQ            4
#define C_NE            5
#define C_GE            6
#define C_LT            7
#define C_VS            8
#define C_VC            9
#define C_GEU           10
#define C_LU            11
#define C_NEG           12
#define C_POS           13
#define C_FGT           14
#define C_FLE           15
#define C_FEQ           16
#define C_FNE           17
#define C_FO            18
#define C_FU            19
#define C_ALWAYS        20
#define C_NEVER         21

#define C_SIZE          22
