/*
 * KROC ALPHA translator: Special instructions for the T9000.
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/f_t9000.c,v $
 *
 * $Id: f_t9000.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995
 * University of Kent at Canterbury
 *
 * None implemented.
 *
 */

static char f_t9000_c_rcsid[] = "$Id: f_t9000.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

void CAUSEERROR ()
{
	unimp ();
}

void CB ()
{
	unimp ();
}

void CBU ()
{
	unimp ();
}

void CS ()
{
	unimp ();
}

void CSU ()
{
	unimp ();
}

void GTU ()
{
	unimp ();
}

void LBX ()
{
	unimp ();
}

void LDCNT ()
{	PUSH;
	unimp ();
}

void LDTH ()			/* what is the trap handler register? */
{	PUSH;
	unimp ();
}

void LS ()
{
	unimp ();
}

void LSX ()
{
	unimp ();
}

void SS ()
{
	unimp ();
}

void SSUB ()
{
	unimp ();
}

void XSWORD ()
{
	unimp ();
}

void VIN ()
{	mnem("call"); str("$$vin"); NL;
	ADJUST; nl;
	istackp = 0;
	ishuff = 0;
}

void VOUT ()
{	mnem("call"); str("$$vout"); NL;
	ADJUST; nl;
	istackp = 0;
	ishuff = 0;
}

#ifdef FLOAT

void FPADDDBSN ()
{
	unimp ();
}

void FPGE ()
{
	unimp ();
}

void FPLG ()
{
	unimp ();
}

void FPREM ()
{
	unimp ();
}

#endif /* FLOAT */
