/* This version is particularly suited to the 3LC version of linkmain.c, etc */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <time.h>
#include <sys/timers.h>
#define HOST_OS_OSF30 1

extern int kbd_sync;
extern int link_sync;
extern void* in_links;
extern int linkdata_stride;
extern int links_pending;

unsigned int rtime (void);
char read_the_kbd (void);
int test_the_kbd (void);
void acknowledge (void);
int safe_pause (void);
void dead (int erfl);

void savecmdline (int argc, char **argv);
void impossible (int reason, int occam_iptr);
void occam_exit (int exit_status, int occam_iptr);
void setalarm (unsigned int timethen, unsigned int dummy, unsigned int timenow);
int enter (void);

int C_outmessage(int len, void * dataptr, int linkno, int wptr);
int C_inmessage(int len, void * dataptr, int linkno, int wptr);

typedef long long int PTRINT;  /* integer that will hold a pointer */

#define save_tty_state()
#define restore_tty_state()

#define THSTACKSIZE 4096       /* stack size for each link thread */
#define NOPROCESS 0x80000000
#define W_Pointer -12
