/*
 * KROC translator: Function definitions and prototypes
 *
 * $Source: /extra/play/cvs/kroc/src/target/arm/arm-ops.h,v $
 *
 * $Id: arm-ops.h,v 1.1 1999/09/27 21:24:00 rivimey Exp $
 *
 * ops.h
 * (C) Copyright 1999 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 */

#ifndef OCTRAN_ARMOPS_H
#define OCTRAN_ARMOPS_H

#include "ops.h"

extern TargetDescriptionProc ArmDescribeTarget;
extern InitialiseProc ArmInit;
extern CloseProc ArmClose;

InstrProc ArmADC;
InstrProc ArmADD;
InstrProc ArmAJW;
InstrProc ArmALT;
InstrProc ArmALTEND;
InstrProc ArmALTWT;
InstrProc ArmAND;
InstrProc ArmBCNT;
InstrProc ArmBITCNT;
InstrProc ArmBITREVNBITS;
InstrProc ArmBITREVWORD;
InstrProc ArmBSUB;
InstrProc ArmCALL;
InstrProc ArmCAUSEERROR;
InstrProc ArmCB;
InstrProc ArmCBU;
InstrProc ArmCCNT1;
InstrProc ArmCFLERR;
InstrProc ArmCJ;
InstrProc ArmCLRHALTERR;
InstrProc ArmCRCBYTE;
InstrProc ArmCRCWORD;
InstrProc ArmCS;
InstrProc ArmCSNGL;
InstrProc ArmCSU;
InstrProc ArmCSUB0;
InstrProc ArmCWORD;
InstrProc ArmDIFF;
InstrProc ArmDISC;
InstrProc ArmDISS;
InstrProc ArmDIST;
InstrProc ArmDIV;
InstrProc ArmDUP;
InstrProc ArmENBC;
InstrProc ArmENBS;
InstrProc ArmENBT;
InstrProc ArmENDP;
InstrProc ArmGAJW;
InstrProc ArmGCALL;
InstrProc ArmGT;
InstrProc ArmGTU;
InstrProc ArmIN;
InstrProc ArmJ;
InstrProc ArmLADD;
InstrProc ArmLB;
InstrProc ArmLBX;
InstrProc ArmLDC;
InstrProc ArmLDCNT;
InstrProc ArmLDIFF;
InstrProc ArmLDINF;
InstrProc ArmLDIV;
InstrProc ArmLDL;
InstrProc ArmLDLP;
InstrProc ArmLDNL;
InstrProc ArmLDNLP;
InstrProc ArmLDPI;
InstrProc ArmLDPRI;
InstrProc ArmLDTH;
InstrProc ArmLDTIMER;
InstrProc ArmLEND;
InstrProc ArmLMUL;
InstrProc ArmLS;
InstrProc ArmLSHL;
InstrProc ArmLSHR;
InstrProc ArmLSUB;
InstrProc ArmLSUM;
InstrProc ArmLSX;
InstrProc ArmMINT;
InstrProc ArmMOVE;
InstrProc ArmMOVE2DALL;
InstrProc ArmMOVE2DINIT;
InstrProc ArmMOVE2DNONZERO;
InstrProc ArmMOVE2DZERO;
InstrProc ArmMUL;
InstrProc ArmNFIX;
InstrProc ArmNORM;
InstrProc ArmNOT;
InstrProc ArmOPR;
InstrProc ArmOR;
InstrProc ArmOUT;
InstrProc ArmOUTBYTE;
InstrProc ArmOUTWORD;
InstrProc ArmPFIX;
InstrProc ArmPOSTNORMSN;
InstrProc ArmPROD;
InstrProc ArmREM;
InstrProc ArmRESETCH;
InstrProc ArmRET;
InstrProc ArmREV;
InstrProc ArmROUNDSN;
InstrProc ArmRUNP;
InstrProc ArmSAVEH;
InstrProc ArmSAVEL;
InstrProc ArmSB;
InstrProc ArmSETERR;
InstrProc ArmSETHALTERR;
InstrProc ArmSHL;
InstrProc ArmSHR;
InstrProc ArmSS;
InstrProc ArmSSUB;
InstrProc ArmSTARTP;
InstrProc ArmSTHB;
InstrProc ArmSTHF;
InstrProc ArmSTL;
InstrProc ArmSTLB;
InstrProc ArmSTLF;
InstrProc ArmSTNL;
InstrProc ArmSTOPERR;
InstrProc ArmSTOPP;
InstrProc ArmSTTIMER;
InstrProc ArmSUB;
InstrProc ArmSUM;
InstrProc ArmTALT;
InstrProc ArmTALTWT;
InstrProc ArmTESTERR;
InstrProc ArmTESTHALTERR;
InstrProc ArmTESTPRANAL;
InstrProc ArmTIN;
InstrProc ArmUNPACKSN;
InstrProc ArmVIN;
InstrProc ArmVOUT;
InstrProc ArmWCNT;
InstrProc ArmWSUB;
InstrProc ArmWSUBDB;
InstrProc ArmXDBLE;
InstrProc ArmXOR;
InstrProc ArmXSWORD;
InstrProc ArmXWORD;

#endif /* OCTRAN_ARMOPS_H */
