/*
 * KROC ALPHA translator: Special instructions for the T9000.
 *
 * $Source: /extra/play/cvs/kroc/src/target/arm/f_t9000.c,v $
 *
 * $Id: f_t9000.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 *
 * arm/f_t9000.c:
 * (C) Copyright 1998 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 * Derived from alpha/f_t9000.c:
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *   /u3/proj/kroc/develop/src/alpha/RCS/f_t9000.c,v
 *   f_t9000.c,v 1.1 1995/10/05 16:29:30 djb1 Exp
 *
 */

static char f_t9000_c_rcsid[] = "$Id: f_t9000.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

void ArmCAUSEERROR ()
{
    unimp ();
}

void ArmCB ()
{
    unimp ();
}

void ArmCBU ()
{
    unimp ();
}

void ArmCS ()
{
    unimp ();
}

void ArmCSU ()
{
    unimp ();
}

void ArmGTU ()
{
    unimp ();
}

void ArmLBX ()
{
    unimp ();
}

void ArmLDCNT ()
{	PUSH;
 unimp ();
}

void ArmLDTH ()			/* what is the trap handler register? */
{	PUSH;
 unimp ();
}

void ArmLS ()
{
    unimp ();
}

void ArmLSX ()
{
    unimp ();
}

void ArmSS ()
{
    unimp ();
}

void ArmSSUB ()
{
    unimp ();
}

void ArmXSWORD ()
{
    unimp ();
}

void ArmVIN ()
{
    unimp ();
}

void ArmVOUT ()
{
    unimp ();
}

#ifdef FLOAT

void ArmFPADDDBSN ()
{
    unimp ();
}

void ArmFPGE ()
{
    unimp ();
}

void ArmFPLG ()
{
    unimp ();
}

void ArmFPREM ()
{
    unimp ();
}

#endif /* FLOAT */
