
!
! KROC ALPHA keyboard channel access for occam
!
! $Source: /extra/play/cvs/kroc/src/target/arm/getkey.s,v $
!
! $Id: getkey.s,v 1.1 1999/09/27 21:10:12 rivimey Exp $
!
! (C) Copyright 1996 M.D. Poole <M.D.Poole@ukc.ac.uk>
! University of Kent at Canterbury
!
! This code is callable from occam and makes direct access to kbd_chan
!

#include <regdef.h>
#include "sched.h"

	.text
MAKENAME(getkey_s_rcsid):
	.ascii	"$Id: getkey.s,v 1.1 1999/09/27 21:10:12 rivimey Exp $\0"

.text
.align 3
L0:     #- PROC S.getkey, lexlevel: 0, WS: 0, VS: 0
	.globl  $S_getkey
$S_getkey:
!        descriptor $S.getkey "S.getkey" occam 0 0 "PROC S.getkey(INT keyval)"

	stl     ra,0(Wptr)
	ldl     REG_0,4(Wptr)            # PTR INT keyval
	lda     REG_1,kbd_chan
	bis     zero,1,REG_2             # count := 1
	jsr     L,$in
	ldl     ra,0(Wptr)
	addl    Wptr,16,Wptr
	jmp     zero,(ra)
L1:     #- PROC S.pollkey, lexlevel: 0, WS: 0, VS: 0
	.globl  $S_pollkey
$S_pollkey:
!        descriptor $S.pollkey "S.pollkey" occam 0 0 "PROC S.pollkey(INT result,INT keyval)"

	stl     ra,0(Wptr)
	lda     REG_1,kbd_chan           # channel address
	ldl     T0,0(REG_1)              # value of channel word
	cmpeq   T0,MIN,P5                # Is it NotProcess.p?
	beq     P5,1f                    # No, there is a key to read
	bis     zero,128,REG_1           # spr.operation.failed
	ldl     REG_2,4(Wptr)            # PTR INT result
	stl     REG_1,0(REG_2)
	ldl     REG_2,8(Wptr)            # PTR INT keyval
	stl     zero,0(REG_2)
	br      2f
1:
	ldl     REG_0,8(Wptr)            # PTR INT keyval
	bis     zero,1,REG_2             # count := 1
	jsr     L,$in
	ldl     REG_2,4(Wptr)            # PTR INT result
	stl     zero,0(REG_2)
2:
	ldl     ra,0(Wptr)
	addl    Wptr,16,Wptr
	jmp     zero,(ra)
	.align  4
