/*
 * KROC SPARC translator: Conditional table offset definitions
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/cond.h,v $
 *
 * $Id: cond.h,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 */


/*	Conditionals				*/
/*	Must be in true/false even/odd pairs	*/

#define C_NONE		0

#define C_GT		2
#define C_LE		3
#define C_EQ		4
#define C_NE		5
#define C_GE		6
#define C_LT		7
#define C_VS		8
#define C_VC		9
#define C_GU		10
#define C_LEU		11
#define C_GEU		12
#define C_LU		13
#define C_NEG		14
#define C_POS		15
#define C_FGT		16
#define C_FLE		17
#define C_FGE		18
#define C_FLT		19
#define C_FEQ		20
#define C_FNE		21
#define C_FLG		22
#define C_FUE		23
#define C_FO		24
#define C_FU		25
#define C_ALWAYS	26
#define C_NEVER		27

#define C_SIZE		28
