--
--	postmortem.inc - constants for post-mortem debugging
--	Copyright (C) 2000 F.R.M. Barnes
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--


VAL PMOP.INVALID IS 0:
VAL PMOP.ADD IS 1:
VAL PMOP.SUB IS 2:
VAL PMOP.MUL IS 3:
VAL PMOP.DIV IS 4:
VAL PMOP.REM IS 5:
VAL PMOP.LADD IS 6:
VAL PMOP.LSUB IS 7:
VAL PMOP.ADC IS 8:
VAL PMOP.STOP IS 9:

VAL DLOP.INVALID IS 0:
VAL DLOP.IN IS 1:
VAL DLOP.OUT IS 2:
VAL DLOP.OUTBYTE IS 3:
VAL DLOP.OUTWORD IS 4:
VAL DLOP.ALTWT IS 5:
VAL DLOP.TALTWT IS 6:

VAL REOP.INVALID IS 0:
VAL REOP.SHIFT IS 1:
VAL REOP.CSNGL IS 2:
VAL REOP.CSUB0 IS 3:
VAL REOP.CCNT1 IS 4:

