--
--	tcoff.inc - TCOFF constants
--	Copyright (C) 1997  M.D. Poole
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

--{{{  TCOFF TAG VALUES
VAL tcoff.ignore.tag IS 0:
VAL linkable.tag IS 1:
VAL start.module.tag IS 2:
VAL end.module.tag IS 3:
VAL set.load.point.tag IS 4:
VAL adjust.point.tag IS 5:
VAL load.text.tag IS 6:
VAL load.prefix.tag IS 7:
VAL load.expr.tag IS 8:
VAL load.zeros.tag IS 9:
VAL align.tag IS 10:
VAL section.tag IS 11:
VAL define.main.tag IS 12:
VAL local.symbols.tag IS 13:
VAL define.label.tag IS 14:
VAL define.symbol.tag IS 15:
VAL kill.id.tag IS 16:
VAL byte.patch.tag IS 17:
VAL rep.start.tag IS 18:
VAL rep.end.tag IS 19:
VAL comment.tag IS 20:
VAL message.tag IS 21:
VAL lib.index.start.tag IS 22:
VAL lib.index.end.tag IS 23:
VAL index.entry.tag IS 24:
VAL word.patch.tag IS 25:
VAL descriptor.tag IS 26:
VAL version.tag IS 27:
VAL linked.unit.tag IS 28:
VAL specify.origin.tag IS 29:
VAL symbol.tag IS 30:
VAL specific.symbol.tag IS 31:
--}}}  
--{{{  debug info tags
VAL RTL.CODEMARK IS 14(BYTE):
--}}}  
--{{{  value tags
VAL co.value.tag IS 1:
VAL lp.value.tag IS 2:
VAL sv.value.tag IS 3:
VAL ss.value.tag IS 4:
VAL wl.value.tag IS 5:
VAL ap.value.tag IS 13:
VAL plus.op IS 6:
VAL minus.op IS 7:
VAL times.op IS 8:
VAL divide.op IS 9:
VAL rem.op IS 10:
VAL max.op IS 11:
VAL min.op IS 12:
--}}}  
--{{{  overflow errors
VAL dbg.oflo IS 1:
VAL rec.oflo IS 2:
VAL utype.oflo IS 3:
VAL names.oflo IS 4:
VAL tcoff.oflo IS 5:
VAL files.oflo IS 6:
VAL var.oflo IS 10:
VAL lex.oflo IS 11:
VAL wsp.oflo IS 12:
VAL arrays.oflo IS 13:
--}}}  
